on mapClick sN
  global gLinkBackMap
  spinCursor()
  set c to sN - 4
  set hOn to the castNum of sprite sN
  set the castNum of sprite sN to cast value(hOn)
  updateStage()
  wait(20)
  set the castNum of sprite sN to cast value(hOn + 1)
  updateStage()
  set gLinkBackMap to EMPTY
  if c = 1 then
    openIV()
  else
    if c = 2 then
      LinkTo("People Cover")
    else
      if c = 3 then
        LinkTo("SB Cover")
      else
        if c = 4 then
          LinkTo("Stage Cover")
        else
          if c = 5 then
            LinkTo("PS Cover")
          else
            if c = 6 then
              LinkTo("AW Cover")
            else
              if c = 7 then
                LinkTo("CD Credits")
              else
                if c = 8 then
                end if
              end if
            end if
          end if
        end if
      end if
    end if
  end if
  startMouse()
end

on linkToPrefs
  global gLinkBackMap
  spinCursor()
  if gLinkBackMap = EMPTY then
    set gLinkBackMap to "LinkTo " & QUOTE & the frameLabel & QUOTE
  end if
  LinkTo("Preferences")
end

on LinkToMap
  global gLinkBackMap
  spinCursor()
  if gLinkBackMap = EMPTY then
    set gLinkBackMap to "LinkTo " & QUOTE & the frameLabel & QUOTE
  end if
  LinkTo("Map")
end

on LinkBackPref
  LinkBackMap()
end

on LinkBackMap
  global gLinkBackMap, gSBState, gPSState, gPeopleState
  spinCursor()
  hidePuppets()
  updateStage()
  tell the stage
    set cmd to gLinkBackMap
    set gLinkBackMap to EMPTY
    spinCursor()
    puppetPalette(the framePalette)
    dissolveEffect()
    go("Black")
    puppetPalette(0)
    dissolveEffect()
    do(cmd)
  end tell
  spinCursor()
  set fName to the frameLabel
  set fNum to the frame
  set peopleStart to marker("Producer BG0") - 1
  set peopleEnd to marker("Production Team BG1") + 1
  if fName = "SB BG" then
    updateSB(value(item 1 of gSBState))
  else
    if fName = "PS BG" then
      spinCursor()
      updatePS(value(item 1 of gPSState))
    else
      if (fNum > peopleStart) and (fNum < peopleEnd) then
        LinkPeopleFromIcon(value(line 2 of gPeopleState))
      end if
    end if
  end if
  resetCursor()
end

on LinkBack
  global gLinkBack, gOnPC, gLastPalette
  stopAiff()
  spinCursor()
  hidePuppets()
  tell the stage
    set cmd to gLinkBack
    set gLinkBack to EMPTY
    if gLastPalette = EMPTY then
      set gLastPalette to the framePalette
    end if
    puppetPalette(gLastPalette)
    set gLastPalette to EMPTY
    spinCursor()
    go("Black")
    spinCursor()
    puppetPalette(0)
    pause()
    updatePalette()
    spinCursor()
    put cmd
    do(cmd)
    continue()
  end tell
end

on updateLinkIcons linkBackMsg, fromPrefix, theStills, theMovie, theSB, thePeople
  global gLinkBack, gLinkStills, gLinkMov, gLinkSB, gLinkPeople, gMovUserViewed, gPSUserViewed
  set gLinkBack to linkBackMsg
  set gLinkStills to theStills
  set gLinkMov to theMovie
  set gLinkSB to theSB
  set gLinkPeople to thePeople
  set sN to 39
  if theStills <> 0 then
    set hasStuff to theStills <> EMPTY
    set oldFlag to getOne(value(gPSUserViewed), value(theStills)) > 0
    set the puppet of sprite sN to 1
    if hasStuff then
      if not oldFlag then
        set the castNum of sprite sN to cast (fromPrefix & "PSOG.PIC")
      else
        set the castNum of sprite sN to cast (fromPrefix & "PSCG.PIC")
      end if
    end if
  end if
  set the visible of sprite sN to not ((theStills = 0) or (hasStuff = 0))
  set sN to 38
  if theMovie <> 0 then
    set hasStuff to theMovie <> EMPTY
    set oldFlag to getOne(gMovUserViewed, theMovie) > 0
    set the puppet of sprite sN to 1
    if hasStuff then
      if not oldFlag then
        set the castNum of sprite sN to cast (fromPrefix & "MOVOG.PIC")
      else
        set the castNum of sprite sN to cast (fromPrefix & "MOVCG.PIC")
      end if
    end if
  end if
  set the visible of sprite sN to not ((theMovie = 0) or (hasStuff = 0))
end

on showLinkedStill
  global gLinkStills, gPSRecords, gPSViewedHere, gSBState
  if (gLinkStills = EMPTY) or voidp(gLinkStills) then
    beep()
  else
    set gPSRecords to value("[" & gLinkStills & "]")
    set gPSViewedHere to 1 && count(gPSRecords)
    set the visible of sprite 31 to 0
    showProdStills("Links", "Storyboard: Scene " & the text of field "SB_Scene" && " - Shot:" && the text of field "SB_Shot")
  end if
end

on showLinkedMov
  global gLinkMov, gSBState
  if (gLinkMov = EMPTY) or voidp(gLinkMov) then
    beep()
  else
    set theLine to LineOffset(gLinkMov, field "MOVTXT_F")
    if theLine > 0 then
      showQT(theLine)
    end if
  end if
end
